
/* Python wrapper functions auto-generated by pidl */
#define PY_SSIZE_T_CLEAN 1 /* We use Py_ssize_t for PyArg_ParseTupleAndKeywords */
#include <Python.h>
#include "python/py3compat.h"
#include "includes.h"
#include <pytalloc.h>
#include "librpc/rpc/pyrpc.h"
#include "librpc/rpc/pyrpc_util.h"
#include "bin/default/librpc/gen_ndr/ndr_remact.h"
#include "bin/default/librpc/gen_ndr/ndr_remact_c.h"

/*
 * These functions are here to ensure they can be optimized out by
 * the compiler based on the constant input values
 */

static inline unsigned long long ndr_sizeof2uintmax(size_t var_size)
{
	switch (var_size) {
	case 8:
		return UINT64_MAX;
	case 4:
		return UINT32_MAX;
	case 2:
		return UINT16_MAX;
	case 1:
		return UINT8_MAX;
	}

	return 0;
}

static inline long long ndr_sizeof2intmax(size_t var_size)
{
	switch (var_size) {
	case 8:
		return INT64_MAX;
	case 4:
		return INT32_MAX;
	case 2:
		return INT16_MAX;
	case 1:
		return INT8_MAX;
	}

	return 0;
}

static inline PyObject *ndr_PyLong_FromLongLong(long long v)
{
	if (v > LONG_MAX || v < LONG_MIN) {
		return PyLong_FromLongLong(v);
	} else {
		return PyInt_FromLong(v);
	}
}

static inline PyObject *ndr_PyLong_FromUnsignedLongLong(unsigned long long v)
{
	if (v > LONG_MAX) {
		return PyLong_FromUnsignedLongLong(v);
	} else {
		return PyInt_FromLong(v);
	}
}

#include "librpc/gen_ndr/misc.h"
#include "librpc/gen_ndr/orpc.h"
static PyTypeObject IRemoteActivation_InterfaceType;
static PyTypeObject RemoteActivation_Type;

static PyTypeObject *ORPCTHIS_Type;
static PyTypeObject *ORPCTHAT_Type;
static PyTypeObject *GUID_Type;
static PyTypeObject *MInterfacePointer_Type;
static PyTypeObject *DUALSTRINGARRAY_Type;
static PyTypeObject *COMVERSION_Type;
static PyTypeObject *BaseObject_Type;
static PyTypeObject *ClientConnection_Type;
static PyTypeObject *ndr_syntax_id_Type;


static PyObject *py_RemoteActivation_in_get_this_object(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_this_object;
	py_this_object = pytalloc_reference_ex(ORPCTHIS_Type, pytalloc_get_mem_ctx(obj), &object->in.this_object);
	return py_this_object;
}

static int py_RemoteActivation_in_set_this_object(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.this_object");
		return -1;
	}
	PY_CHECK_TYPE(ORPCTHIS_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->in.this_object = *(struct ORPCTHIS *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_RemoteActivation_out_get_that(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_that;
	py_that = pytalloc_reference_ex(ORPCTHAT_Type, object->out.that, object->out.that);
	return py_that;
}

static int py_RemoteActivation_out_set_that(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	talloc_unlink(pytalloc_get_mem_ctx(py_obj), discard_const(object->out.that));
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->out.that");
		return -1;
	}
	object->out.that = talloc_ptrtype(pytalloc_get_mem_ctx(py_obj), object->out.that);
	if (object->out.that == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	PY_CHECK_TYPE(ORPCTHAT_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->out.that = (struct ORPCTHAT *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_RemoteActivation_in_get_Clsid(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_Clsid;
	py_Clsid = pytalloc_reference_ex(GUID_Type, pytalloc_get_mem_ctx(obj), &object->in.Clsid);
	return py_Clsid;
}

static int py_RemoteActivation_in_set_Clsid(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.Clsid");
		return -1;
	}
	PY_CHECK_TYPE(GUID_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->in.Clsid = *(struct GUID *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_RemoteActivation_in_get_pwszObjectName(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_pwszObjectName;
	if (object->in.pwszObjectName == NULL) {
		py_pwszObjectName = Py_None;
		Py_INCREF(py_pwszObjectName);
	} else {
		if (object->in.pwszObjectName == NULL) {
			py_pwszObjectName = Py_None;
			Py_INCREF(py_pwszObjectName);
		} else {
			py_pwszObjectName = PyUnicode_Decode(object->in.pwszObjectName, strlen(object->in.pwszObjectName), "utf-8", "ignore");
		}
	}
	return py_pwszObjectName;
}

static int py_RemoteActivation_in_set_pwszObjectName(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.pwszObjectName");
		return -1;
	}
	if (value == Py_None) {
		object->in.pwszObjectName = NULL;
	} else {
		object->in.pwszObjectName = NULL;
		{
			const char *test_str;
			const char *talloc_str;
			PyObject *unicode = NULL;
			if (PyUnicode_Check(value)) {
				unicode = PyUnicode_AsEncodedString(value, "utf-8", "ignore");
				if (unicode == NULL) {
					PyErr_NoMemory();
					return -1;
				}
				test_str = PyBytes_AS_STRING(unicode);
			} else if (PyBytes_Check(value)) {
				test_str = PyBytes_AS_STRING(value);
			} else {
				PyErr_Format(PyExc_TypeError, "Expected string or unicode object, got %s", Py_TYPE(value)->tp_name);
				return -1;
			}
			talloc_str = talloc_strdup(pytalloc_get_mem_ctx(py_obj), test_str);
			if (unicode != NULL) {
				Py_DECREF(unicode);
			}
			if (talloc_str == NULL) {
				PyErr_NoMemory();
				return -1;
			}
			object->in.pwszObjectName = talloc_str;
		}
	}
	return 0;
}

static PyObject *py_RemoteActivation_in_get_pObjectStorage(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_pObjectStorage;
	if (object->in.pObjectStorage == NULL) {
		py_pObjectStorage = Py_None;
		Py_INCREF(py_pObjectStorage);
	} else {
		py_pObjectStorage = pytalloc_reference_ex(MInterfacePointer_Type, object->in.pObjectStorage, object->in.pObjectStorage);
	}
	return py_pObjectStorage;
}

static int py_RemoteActivation_in_set_pObjectStorage(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	talloc_unlink(pytalloc_get_mem_ctx(py_obj), discard_const(object->in.pObjectStorage));
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.pObjectStorage");
		return -1;
	}
	if (value == Py_None) {
		object->in.pObjectStorage = NULL;
	} else {
		object->in.pObjectStorage = NULL;
		PY_CHECK_TYPE(MInterfacePointer_Type, value, return -1;);
		if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
			PyErr_NoMemory();
			return -1;
		}
		object->in.pObjectStorage = (struct MInterfacePointer *)pytalloc_get_ptr(value);
	}
	return 0;
}

static PyObject *py_RemoteActivation_in_get_ClientImpLevel(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_ClientImpLevel;
	py_ClientImpLevel = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->in.ClientImpLevel);
	return py_ClientImpLevel;
}

static int py_RemoteActivation_in_set_ClientImpLevel(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.ClientImpLevel");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->in.ClientImpLevel));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->in.ClientImpLevel = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->in.ClientImpLevel = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_RemoteActivation_in_get_Mode(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_Mode;
	py_Mode = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->in.Mode);
	return py_Mode;
}

static int py_RemoteActivation_in_set_Mode(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.Mode");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->in.Mode));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->in.Mode = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->in.Mode = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_RemoteActivation_in_get_Interfaces(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_Interfaces;
	py_Interfaces = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->in.Interfaces);
	return py_Interfaces;
}

static int py_RemoteActivation_in_set_Interfaces(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.Interfaces");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->in.Interfaces));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->in.Interfaces = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->in.Interfaces = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_RemoteActivation_in_get_pIIDs(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_pIIDs;
	if (object->in.pIIDs == NULL) {
		py_pIIDs = Py_None;
		Py_INCREF(py_pIIDs);
	} else {
		py_pIIDs = PyList_New(object->in.Interfaces);
		if (py_pIIDs == NULL) {
			return NULL;
		}
		{
			int pIIDs_cntr_1;
			for (pIIDs_cntr_1 = 0; pIIDs_cntr_1 < (object->in.Interfaces); pIIDs_cntr_1++) {
				PyObject *py_pIIDs_1;
				py_pIIDs_1 = pytalloc_reference_ex(GUID_Type, object->in.pIIDs, &object->in.pIIDs[pIIDs_cntr_1]);
				PyList_SetItem(py_pIIDs, pIIDs_cntr_1, py_pIIDs_1);
			}
		}
	}
	return py_pIIDs;
}

static int py_RemoteActivation_in_set_pIIDs(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	talloc_unlink(pytalloc_get_mem_ctx(py_obj), discard_const(object->in.pIIDs));
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.pIIDs");
		return -1;
	}
	if (value == Py_None) {
		object->in.pIIDs = NULL;
	} else {
		object->in.pIIDs = NULL;
		PY_CHECK_TYPE(&PyList_Type, value, return -1;);
		{
			int pIIDs_cntr_1;
			object->in.pIIDs = talloc_array_ptrtype(pytalloc_get_mem_ctx(py_obj), object->in.pIIDs, PyList_GET_SIZE(value));
			if (!object->in.pIIDs) { return -1;; }
			talloc_set_name_const(object->in.pIIDs, "ARRAY: object->in.pIIDs");
			for (pIIDs_cntr_1 = 0; pIIDs_cntr_1 < PyList_GET_SIZE(value); pIIDs_cntr_1++) {
				if (PyList_GET_ITEM(value, pIIDs_cntr_1) == NULL) {
					PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.pIIDs[pIIDs_cntr_1]");
					return -1;
				}
				PY_CHECK_TYPE(GUID_Type, PyList_GET_ITEM(value, pIIDs_cntr_1), return -1;);
				if (talloc_reference(object->in.pIIDs, pytalloc_get_mem_ctx(PyList_GET_ITEM(value, pIIDs_cntr_1))) == NULL) {
					PyErr_NoMemory();
					return -1;
				}
				object->in.pIIDs[pIIDs_cntr_1] = *(struct GUID *)pytalloc_get_ptr(PyList_GET_ITEM(value, pIIDs_cntr_1));
			}
		}
	}
	return 0;
}

static PyObject *py_RemoteActivation_in_get_num_protseqs(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_num_protseqs;
	py_num_protseqs = PyInt_FromLong((uint16_t)object->in.num_protseqs);
	return py_num_protseqs;
}

static int py_RemoteActivation_in_set_num_protseqs(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.num_protseqs");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->in.num_protseqs));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->in.num_protseqs = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->in.num_protseqs = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_RemoteActivation_in_get_protseq(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_protseq;
	py_protseq = PyList_New(object->in.num_protseqs);
	if (py_protseq == NULL) {
		return NULL;
	}
	{
		int protseq_cntr_0;
		for (protseq_cntr_0 = 0; protseq_cntr_0 < (object->in.num_protseqs); protseq_cntr_0++) {
			PyObject *py_protseq_0;
			py_protseq_0 = PyInt_FromLong((uint16_t)object->in.protseq[protseq_cntr_0]);
			PyList_SetItem(py_protseq, protseq_cntr_0, py_protseq_0);
		}
	}
	return py_protseq;
}

static int py_RemoteActivation_in_set_protseq(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.protseq");
		return -1;
	}
	PY_CHECK_TYPE(&PyList_Type, value, return -1;);
	{
		int protseq_cntr_0;
		object->in.protseq = talloc_array_ptrtype(pytalloc_get_mem_ctx(py_obj), object->in.protseq, PyList_GET_SIZE(value));
		if (!object->in.protseq) { return -1;; }
		talloc_set_name_const(object->in.protseq, "ARRAY: object->in.protseq");
		for (protseq_cntr_0 = 0; protseq_cntr_0 < PyList_GET_SIZE(value); protseq_cntr_0++) {
			if (PyList_GET_ITEM(value, protseq_cntr_0) == NULL) {
				PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->in.protseq[protseq_cntr_0]");
				return -1;
			}
			{
				const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->in.protseq[protseq_cntr_0]));
				if (PyLong_Check(PyList_GET_ITEM(value, protseq_cntr_0))) {
					unsigned long long test_var;
					test_var = PyLong_AsUnsignedLongLong(PyList_GET_ITEM(value, protseq_cntr_0));
					if (PyErr_Occurred() != NULL) {
						return -1;
					}
					if (test_var > uint_max) {
						PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
						  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
						return -1;
					}
					object->in.protseq[protseq_cntr_0] = test_var;
				} else if (PyInt_Check(PyList_GET_ITEM(value, protseq_cntr_0))) {
					long test_var;
					test_var = PyInt_AsLong(PyList_GET_ITEM(value, protseq_cntr_0));
					if (test_var < 0 || (unsigned long long)test_var > uint_max) {
						PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
						  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
						return -1;
					}
					object->in.protseq[protseq_cntr_0] = test_var;
				} else {
					PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
					  PyInt_Type.tp_name, PyLong_Type.tp_name);
					return -1;
				}
			}
		}
	}
	return 0;
}

static PyObject *py_RemoteActivation_out_get_pOxid(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_pOxid;
	py_pOxid = ndr_PyLong_FromUnsignedLongLong(*object->out.pOxid);
	return py_pOxid;
}

static int py_RemoteActivation_out_set_pOxid(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	talloc_unlink(pytalloc_get_mem_ctx(py_obj), discard_const(object->out.pOxid));
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->out.pOxid");
		return -1;
	}
	object->out.pOxid = talloc_ptrtype(pytalloc_get_mem_ctx(py_obj), object->out.pOxid);
	if (object->out.pOxid == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(*object->out.pOxid));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			*object->out.pOxid = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			*object->out.pOxid = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_RemoteActivation_out_get_pdsaOxidBindings(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_pdsaOxidBindings;
	if (*object->out.pdsaOxidBindings == NULL) {
		py_pdsaOxidBindings = Py_None;
		Py_INCREF(py_pdsaOxidBindings);
	} else {
		py_pdsaOxidBindings = pytalloc_reference_ex(DUALSTRINGARRAY_Type, *object->out.pdsaOxidBindings, *object->out.pdsaOxidBindings);
	}
	return py_pdsaOxidBindings;
}

static int py_RemoteActivation_out_set_pdsaOxidBindings(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	talloc_unlink(pytalloc_get_mem_ctx(py_obj), discard_const(object->out.pdsaOxidBindings));
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->out.pdsaOxidBindings");
		return -1;
	}
	object->out.pdsaOxidBindings = talloc_ptrtype(pytalloc_get_mem_ctx(py_obj), object->out.pdsaOxidBindings);
	if (object->out.pdsaOxidBindings == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	if (value == Py_None) {
		*object->out.pdsaOxidBindings = NULL;
	} else {
		*object->out.pdsaOxidBindings = NULL;
		PY_CHECK_TYPE(DUALSTRINGARRAY_Type, value, return -1;);
		if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
			PyErr_NoMemory();
			return -1;
		}
		*object->out.pdsaOxidBindings = (struct DUALSTRINGARRAY *)pytalloc_get_ptr(value);
	}
	return 0;
}

static PyObject *py_RemoteActivation_out_get_ipidRemUnknown(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_ipidRemUnknown;
	py_ipidRemUnknown = pytalloc_reference_ex(GUID_Type, object->out.ipidRemUnknown, object->out.ipidRemUnknown);
	return py_ipidRemUnknown;
}

static int py_RemoteActivation_out_set_ipidRemUnknown(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	talloc_unlink(pytalloc_get_mem_ctx(py_obj), discard_const(object->out.ipidRemUnknown));
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->out.ipidRemUnknown");
		return -1;
	}
	object->out.ipidRemUnknown = talloc_ptrtype(pytalloc_get_mem_ctx(py_obj), object->out.ipidRemUnknown);
	if (object->out.ipidRemUnknown == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	PY_CHECK_TYPE(GUID_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->out.ipidRemUnknown = (struct GUID *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_RemoteActivation_out_get_AuthnHint(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_AuthnHint;
	py_AuthnHint = ndr_PyLong_FromUnsignedLongLong((uint32_t)*object->out.AuthnHint);
	return py_AuthnHint;
}

static int py_RemoteActivation_out_set_AuthnHint(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	talloc_unlink(pytalloc_get_mem_ctx(py_obj), discard_const(object->out.AuthnHint));
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->out.AuthnHint");
		return -1;
	}
	object->out.AuthnHint = talloc_ptrtype(pytalloc_get_mem_ctx(py_obj), object->out.AuthnHint);
	if (object->out.AuthnHint == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(*object->out.AuthnHint));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			*object->out.AuthnHint = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			*object->out.AuthnHint = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_RemoteActivation_out_get_ServerVersion(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_ServerVersion;
	py_ServerVersion = pytalloc_reference_ex(COMVERSION_Type, object->out.ServerVersion, object->out.ServerVersion);
	return py_ServerVersion;
}

static int py_RemoteActivation_out_set_ServerVersion(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	talloc_unlink(pytalloc_get_mem_ctx(py_obj), discard_const(object->out.ServerVersion));
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->out.ServerVersion");
		return -1;
	}
	object->out.ServerVersion = talloc_ptrtype(pytalloc_get_mem_ctx(py_obj), object->out.ServerVersion);
	if (object->out.ServerVersion == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	PY_CHECK_TYPE(COMVERSION_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->out.ServerVersion = (struct COMVERSION *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_RemoteActivation_out_get_hr(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_hr;
	py_hr = PyErr_FromHRESULT(*object->out.hr);
	return py_hr;
}

static int py_RemoteActivation_out_set_hr(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	talloc_unlink(pytalloc_get_mem_ctx(py_obj), discard_const(object->out.hr));
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->out.hr");
		return -1;
	}
	object->out.hr = talloc_ptrtype(pytalloc_get_mem_ctx(py_obj), object->out.hr);
	if (object->out.hr == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	*object->out.hr = HRES_ERROR(PyInt_AsLong(value));
	return 0;
}

static PyObject *py_RemoteActivation_out_get_ifaces(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_ifaces;
	py_ifaces = PyList_New(object->in.Interfaces);
	if (py_ifaces == NULL) {
		return NULL;
	}
	{
		int ifaces_cntr_1;
		for (ifaces_cntr_1 = 0; ifaces_cntr_1 < (object->in.Interfaces); ifaces_cntr_1++) {
			PyObject *py_ifaces_1;
			if (object->out.ifaces[ifaces_cntr_1] == NULL) {
				py_ifaces_1 = Py_None;
				Py_INCREF(py_ifaces_1);
			} else {
				py_ifaces_1 = pytalloc_reference_ex(MInterfacePointer_Type, object->out.ifaces[ifaces_cntr_1], object->out.ifaces[ifaces_cntr_1]);
			}
			PyList_SetItem(py_ifaces, ifaces_cntr_1, py_ifaces_1);
		}
	}
	return py_ifaces;
}

static int py_RemoteActivation_out_set_ifaces(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	talloc_unlink(pytalloc_get_mem_ctx(py_obj), discard_const(object->out.ifaces));
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->out.ifaces");
		return -1;
	}
	object->out.ifaces = talloc_ptrtype(pytalloc_get_mem_ctx(py_obj), object->out.ifaces);
	if (object->out.ifaces == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	PY_CHECK_TYPE(&PyList_Type, value, return -1;);
	{
		int ifaces_cntr_1;
		object->out.ifaces = talloc_array_ptrtype(pytalloc_get_mem_ctx(py_obj), object->out.ifaces, PyList_GET_SIZE(value));
		if (!object->out.ifaces) { return -1;; }
		talloc_set_name_const(object->out.ifaces, "ARRAY: object->out.ifaces");
		for (ifaces_cntr_1 = 0; ifaces_cntr_1 < PyList_GET_SIZE(value); ifaces_cntr_1++) {
			if (PyList_GET_ITEM(value, ifaces_cntr_1) == NULL) {
				PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->out.ifaces[ifaces_cntr_1]");
				return -1;
			}
			if (PyList_GET_ITEM(value, ifaces_cntr_1) == Py_None) {
				object->out.ifaces[ifaces_cntr_1] = NULL;
			} else {
				object->out.ifaces[ifaces_cntr_1] = NULL;
				PY_CHECK_TYPE(MInterfacePointer_Type, PyList_GET_ITEM(value, ifaces_cntr_1), return -1;);
				if (talloc_reference(object->out.ifaces, pytalloc_get_mem_ctx(PyList_GET_ITEM(value, ifaces_cntr_1))) == NULL) {
					PyErr_NoMemory();
					return -1;
				}
				object->out.ifaces[ifaces_cntr_1] = (struct MInterfacePointer *)pytalloc_get_ptr(PyList_GET_ITEM(value, ifaces_cntr_1));
			}
		}
	}
	return 0;
}

static PyObject *py_RemoteActivation_out_get_results(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_results;
	py_results = PyList_New(object->in.Interfaces);
	if (py_results == NULL) {
		return NULL;
	}
	{
		int results_cntr_0;
		for (results_cntr_0 = 0; results_cntr_0 < (object->in.Interfaces); results_cntr_0++) {
			PyObject *py_results_0;
			py_results_0 = PyErr_FromHRESULT(object->out.results[results_cntr_0]);
			PyList_SetItem(py_results, results_cntr_0, py_results_0);
		}
	}
	return py_results;
}

static int py_RemoteActivation_out_set_results(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->out.results");
		return -1;
	}
	PY_CHECK_TYPE(&PyList_Type, value, return -1;);
	{
		int results_cntr_0;
		object->out.results = talloc_array_ptrtype(pytalloc_get_mem_ctx(py_obj), object->out.results, PyList_GET_SIZE(value));
		if (!object->out.results) { return -1;; }
		talloc_set_name_const(object->out.results, "ARRAY: object->out.results");
		for (results_cntr_0 = 0; results_cntr_0 < PyList_GET_SIZE(value); results_cntr_0++) {
			if (PyList_GET_ITEM(value, results_cntr_0) == NULL) {
				PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->out.results[results_cntr_0]");
				return -1;
			}
			object->out.results[results_cntr_0] = HRES_ERROR(PyInt_AsLong(PyList_GET_ITEM(value, results_cntr_0)));
		}
	}
	return 0;
}

static PyObject *py_RemoteActivation_get_result(PyObject *obj, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(obj);
	PyObject *py_result;
	py_result = PyErr_FromWERROR(object->out.result);
	return py_result;
}

static int py_RemoteActivation_set_result(PyObject *py_obj, PyObject *value, void *closure)
{
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->out.result");
		return -1;
	}
	object->out.result = W_ERROR(PyInt_AsLong(value));
	return 0;
}

static PyGetSetDef py_RemoteActivation_getsetters[] = {
	{
		.name = discard_const_p(char, "in_this_object"),
		.get = py_RemoteActivation_in_get_this_object,
		.set = py_RemoteActivation_in_set_this_object,
		.doc = discard_const_p(char, "PIDL-generated element of base type ORPCTHIS")
	},
	{
		.name = discard_const_p(char, "out_that"),
		.get = py_RemoteActivation_out_get_that,
		.set = py_RemoteActivation_out_set_that,
		.doc = discard_const_p(char, "PIDL-generated element of base type ORPCTHAT")
	},
	{
		.name = discard_const_p(char, "in_Clsid"),
		.get = py_RemoteActivation_in_get_Clsid,
		.set = py_RemoteActivation_in_set_Clsid,
		.doc = discard_const_p(char, "PIDL-generated element of base type GUID")
	},
	{
		.name = discard_const_p(char, "in_pwszObjectName"),
		.get = py_RemoteActivation_in_get_pwszObjectName,
		.set = py_RemoteActivation_in_set_pwszObjectName,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint16")
	},
	{
		.name = discard_const_p(char, "in_pObjectStorage"),
		.get = py_RemoteActivation_in_get_pObjectStorage,
		.set = py_RemoteActivation_in_set_pObjectStorage,
		.doc = discard_const_p(char, "PIDL-generated element of base type MInterfacePointer")
	},
	{
		.name = discard_const_p(char, "in_ClientImpLevel"),
		.get = py_RemoteActivation_in_get_ClientImpLevel,
		.set = py_RemoteActivation_in_set_ClientImpLevel,
		.doc = discard_const_p(char, "PIDL-generated element of base type imp_levels")
	},
	{
		.name = discard_const_p(char, "in_Mode"),
		.get = py_RemoteActivation_in_get_Mode,
		.set = py_RemoteActivation_in_set_Mode,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "in_Interfaces"),
		.get = py_RemoteActivation_in_get_Interfaces,
		.set = py_RemoteActivation_in_set_Interfaces,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "in_pIIDs"),
		.get = py_RemoteActivation_in_get_pIIDs,
		.set = py_RemoteActivation_in_set_pIIDs,
		.doc = discard_const_p(char, "PIDL-generated element of base type GUID")
	},
	{
		.name = discard_const_p(char, "in_num_protseqs"),
		.get = py_RemoteActivation_in_get_num_protseqs,
		.set = py_RemoteActivation_in_set_num_protseqs,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint16")
	},
	{
		.name = discard_const_p(char, "in_protseq"),
		.get = py_RemoteActivation_in_get_protseq,
		.set = py_RemoteActivation_in_set_protseq,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint16")
	},
	{
		.name = discard_const_p(char, "out_pOxid"),
		.get = py_RemoteActivation_out_get_pOxid,
		.set = py_RemoteActivation_out_set_pOxid,
		.doc = discard_const_p(char, "PIDL-generated element of base type hyper")
	},
	{
		.name = discard_const_p(char, "out_pdsaOxidBindings"),
		.get = py_RemoteActivation_out_get_pdsaOxidBindings,
		.set = py_RemoteActivation_out_set_pdsaOxidBindings,
		.doc = discard_const_p(char, "PIDL-generated element of base type DUALSTRINGARRAY")
	},
	{
		.name = discard_const_p(char, "out_ipidRemUnknown"),
		.get = py_RemoteActivation_out_get_ipidRemUnknown,
		.set = py_RemoteActivation_out_set_ipidRemUnknown,
		.doc = discard_const_p(char, "PIDL-generated element of base type GUID")
	},
	{
		.name = discard_const_p(char, "out_AuthnHint"),
		.get = py_RemoteActivation_out_get_AuthnHint,
		.set = py_RemoteActivation_out_set_AuthnHint,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "out_ServerVersion"),
		.get = py_RemoteActivation_out_get_ServerVersion,
		.set = py_RemoteActivation_out_set_ServerVersion,
		.doc = discard_const_p(char, "PIDL-generated element of base type COMVERSION")
	},
	{
		.name = discard_const_p(char, "out_hr"),
		.get = py_RemoteActivation_out_get_hr,
		.set = py_RemoteActivation_out_set_hr,
		.doc = discard_const_p(char, "PIDL-generated element of base type HRESULT")
	},
	{
		.name = discard_const_p(char, "out_ifaces"),
		.get = py_RemoteActivation_out_get_ifaces,
		.set = py_RemoteActivation_out_set_ifaces,
		.doc = discard_const_p(char, "PIDL-generated element of base type MInterfacePointer")
	},
	{
		.name = discard_const_p(char, "out_results"),
		.get = py_RemoteActivation_out_get_results,
		.set = py_RemoteActivation_out_set_results,
		.doc = discard_const_p(char, "PIDL-generated element of base type HRESULT")
	},
	{
		.name = discard_const_p(char, "result"),
		.get = py_RemoteActivation_get_result,
		.set = py_RemoteActivation_set_result,
		.doc = discard_const_p(char, "PIDL-generated element of type WERROR")
	},
	{ .name = NULL }
};

static PyObject *py_RemoteActivation_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct RemoteActivation, type);
}

static PyObject *py_RemoteActivation_ndr_opnum(PyTypeObject *type)
{


	return PyInt_FromLong(0);
}

static PyObject *py_RemoteActivation_ndr_pack(PyObject *py_obj, int ndr_inout_flags, uint32_t ndr_push_flags)
{
	const struct ndr_interface_call *call = NULL;
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	struct ndr_push *push = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;

	if (ndr_table_IRemoteActivation.num_calls < 1) {
		PyErr_SetString(PyExc_TypeError, "Internal Error, ndr_interface_call missing for py_RemoteActivation_ndr_pack");
		return NULL;
	}
	call = &ndr_table_IRemoteActivation.calls[0];

	push = ndr_push_init_ctx(pytalloc_get_mem_ctx(py_obj));
	if (push == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}

	push->flags |= ndr_push_flags;

	err = call->ndr_push(push, ndr_inout_flags, object);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(push);
		PyErr_SetNdrError(err);
		return NULL;
	}
	blob = ndr_push_blob(push);
	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(push);
	return ret;
}

static PyObject *py_RemoteActivation_ndr_pack_in(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	const char * const kwnames[] = { "bigendian", "ndr64", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_push_flags = 0;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|OO:__ndr_pack_in__",
		discard_const_p(char *, kwnames),
		&bigendian_obj,
		&ndr64_obj)) {
		return NULL;
	}

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_NDR64;
	}

	return py_RemoteActivation_ndr_pack(py_obj, NDR_IN, ndr_push_flags);
}

static PyObject *py_RemoteActivation_ndr_pack_out(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	const char * const kwnames[] = { "bigendian", "ndr64", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_push_flags = 0;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|OO:__ndr_pack_out__",
		discard_const_p(char *, kwnames),
		&bigendian_obj,
		&ndr64_obj)) {
		return NULL;
	}

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_push_flags |= LIBNDR_FLAG_NDR64;
	}

	return py_RemoteActivation_ndr_pack(py_obj, NDR_OUT, ndr_push_flags);
}

static PyObject *py_RemoteActivation_ndr_unpack(PyObject *py_obj, const DATA_BLOB *blob, int ndr_inout_flags, uint32_t ndr_pull_flags, bool allow_remaining)
{
	const struct ndr_interface_call *call = NULL;
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	struct ndr_pull *pull = NULL;
	enum ndr_err_code err;

	if (ndr_table_IRemoteActivation.num_calls < 1) {
		PyErr_SetString(PyExc_TypeError, "Internal Error, ndr_interface_call missing for py_RemoteActivation_ndr_unpack");
		return NULL;
	}
	call = &ndr_table_IRemoteActivation.calls[0];

	pull = ndr_pull_init_blob(blob, object);
	if (pull == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}

	pull->flags |= ndr_pull_flags;

	err = call->ndr_pull(pull, ndr_inout_flags, object);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(pull);
		PyErr_SetNdrError(err);
		return NULL;
	}
	if (!allow_remaining) {
		uint32_t highest_ofs;

		if (pull->offset > pull->relative_highest_offset) {
			highest_ofs = pull->offset;
		} else {
			highest_ofs = pull->relative_highest_offset;
		}
		if (highest_ofs < pull->data_size) {
			err = ndr_pull_error(pull, NDR_ERR_UNREAD_BYTES,
				"not all bytes consumed ofs[%u] size[%u]",
				highest_ofs, pull->data_size);
			TALLOC_FREE(pull);
			PyErr_SetNdrError(err);
			return NULL;
		}
	}

	TALLOC_FREE(pull);
	Py_RETURN_NONE;
}

static PyObject *py_RemoteActivation_ndr_unpack_in(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	const char * const kwnames[] = { "data_blob", "bigendian", "ndr64", "allow_remaining", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_pull_flags = LIBNDR_FLAG_REF_ALLOC;
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|OOO:__ndr_unpack_in__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&bigendian_obj,
		&ndr64_obj,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_NDR64;
	}

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	return py_RemoteActivation_ndr_unpack(py_obj, &blob, NDR_IN, ndr_pull_flags, allow_remaining);
}

static PyObject *py_RemoteActivation_ndr_unpack_out(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	const char * const kwnames[] = { "data_blob", "bigendian", "ndr64", "allow_remaining", NULL };
	PyObject *bigendian_obj = NULL;
	PyObject *ndr64_obj = NULL;
	uint32_t ndr_pull_flags = LIBNDR_FLAG_REF_ALLOC;
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|OOO:__ndr_unpack_out__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&bigendian_obj,
		&ndr64_obj,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (bigendian_obj && PyObject_IsTrue(bigendian_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_BIGENDIAN;
	}
	if (ndr64_obj && PyObject_IsTrue(ndr64_obj)) {
		ndr_pull_flags |= LIBNDR_FLAG_NDR64;
	}

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	return py_RemoteActivation_ndr_unpack(py_obj, &blob, NDR_OUT, ndr_pull_flags, allow_remaining);
}

static PyObject *py_RemoteActivation_ndr_print(PyObject *py_obj, const char *name, int ndr_inout_flags)
{
	const struct ndr_interface_call *call = NULL;
	struct RemoteActivation *object = (struct RemoteActivation *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	if (ndr_table_IRemoteActivation.num_calls < 1) {
		PyErr_SetString(PyExc_TypeError, "Internal Error, ndr_interface_call missing for py_RemoteActivation_ndr_print");
		return NULL;
	}
	call = &ndr_table_IRemoteActivation.calls[0];

	retstr = ndr_print_function_string(pytalloc_get_mem_ctx(py_obj), call->ndr_print, name, ndr_inout_flags, object);
	ret = PyStr_FromString(retstr);
	TALLOC_FREE(retstr);

	return ret;
}

static PyObject *py_RemoteActivation_ndr_print_in(PyObject *py_obj, PyObject *py_obj2)
{
	return py_RemoteActivation_ndr_print(py_obj, "RemoteActivation_in", NDR_IN);
}

static PyObject *py_RemoteActivation_ndr_print_out(PyObject *py_obj, PyObject *py_obj2)
{
	return py_RemoteActivation_ndr_print(py_obj, "RemoteActivation_out", NDR_OUT);
}

static PyMethodDef py_RemoteActivation_methods[] = {
	{ "opnum", (PyCFunction)py_RemoteActivation_ndr_opnum, METH_NOARGS|METH_CLASS,
		"remact.RemoteActivation.opnum() -> 0 (0x00) " },
	{ "__ndr_pack_in__", (PyCFunction)py_RemoteActivation_ndr_pack_in, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_pack_in(object, bigendian=False, ndr64=False) -> blob\nNDR pack input" },
	{ "__ndr_pack_out__", (PyCFunction)py_RemoteActivation_ndr_pack_out, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_pack_out(object, bigendian=False, ndr64=False) -> blob\nNDR pack output" },
	{ "__ndr_unpack_in__", (PyCFunction)py_RemoteActivation_ndr_unpack_in, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_unpack_in(class, blob, bigendian=False, ndr64=False, allow_remaining=False) -> None\nNDR unpack input" },
	{ "__ndr_unpack_out__", (PyCFunction)py_RemoteActivation_ndr_unpack_out, METH_VARARGS|METH_KEYWORDS,
		"S.ndr_unpack_out(class, blob, bigendian=False, ndr64=False, allow_remaining=False) -> None\nNDR unpack output" },
	{ "__ndr_print_in__", (PyCFunction)py_RemoteActivation_ndr_print_in, METH_NOARGS, "S.ndr_print_in(object) -> None\nNDR print input" },
	{ "__ndr_print_out__", (PyCFunction)py_RemoteActivation_ndr_print_out, METH_NOARGS, "S.ndr_print_out(object) -> None\nNDR print output" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject RemoteActivation_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "remact.RemoteActivation",
	.tp_getset = py_RemoteActivation_getsetters,
	.tp_methods = py_RemoteActivation_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_RemoteActivation_new,
};

static bool pack_py_RemoteActivation_args_in(PyObject *args, PyObject *kwargs, struct RemoteActivation *r)
{
	PyObject *py_this_object;
	PyObject *py_Clsid;
	PyObject *py_pwszObjectName;
	PyObject *py_pObjectStorage;
	PyObject *py_ClientImpLevel;
	PyObject *py_Mode;
	PyObject *py_pIIDs;
	PyObject *py_protseq;
	const char *kwnames[] = {
		"this_object", "Clsid", "pwszObjectName", "pObjectStorage", "ClientImpLevel", "Mode", "pIIDs", "protseq", NULL
	};

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, "OOOOOOOO:RemoteActivation", discard_const_p(char *, kwnames), &py_this_object, &py_Clsid, &py_pwszObjectName, &py_pObjectStorage, &py_ClientImpLevel, &py_Mode, &py_pIIDs, &py_protseq)) {
		return false;
	}

	if (py_this_object == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.this_object");
		return false;
	}
	PY_CHECK_TYPE(ORPCTHIS_Type, py_this_object, return false;);
	if (talloc_reference(r, pytalloc_get_mem_ctx(py_this_object)) == NULL) {
		PyErr_NoMemory();
		return false;
	}
	r->in.this_object = *(struct ORPCTHIS *)pytalloc_get_ptr(py_this_object);
	if (py_Clsid == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.Clsid");
		return false;
	}
	PY_CHECK_TYPE(GUID_Type, py_Clsid, return false;);
	if (talloc_reference(r, pytalloc_get_mem_ctx(py_Clsid)) == NULL) {
		PyErr_NoMemory();
		return false;
	}
	r->in.Clsid = *(struct GUID *)pytalloc_get_ptr(py_Clsid);
	if (py_pwszObjectName == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.pwszObjectName");
		return false;
	}
	if (py_pwszObjectName == Py_None) {
		r->in.pwszObjectName = NULL;
	} else {
		r->in.pwszObjectName = NULL;
		{
			const char *test_str;
			const char *talloc_str;
			PyObject *unicode = NULL;
			if (PyUnicode_Check(py_pwszObjectName)) {
				unicode = PyUnicode_AsEncodedString(py_pwszObjectName, "utf-8", "ignore");
				if (unicode == NULL) {
					PyErr_NoMemory();
					return false;
				}
				test_str = PyBytes_AS_STRING(unicode);
			} else if (PyBytes_Check(py_pwszObjectName)) {
				test_str = PyBytes_AS_STRING(py_pwszObjectName);
			} else {
				PyErr_Format(PyExc_TypeError, "Expected string or unicode object, got %s", Py_TYPE(py_pwszObjectName)->tp_name);
				return false;
			}
			talloc_str = talloc_strdup(r, test_str);
			if (unicode != NULL) {
				Py_DECREF(unicode);
			}
			if (talloc_str == NULL) {
				PyErr_NoMemory();
				return false;
			}
			r->in.pwszObjectName = talloc_str;
		}
	}
	if (py_pObjectStorage == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.pObjectStorage");
		return false;
	}
	if (py_pObjectStorage == Py_None) {
		r->in.pObjectStorage = NULL;
	} else {
		r->in.pObjectStorage = NULL;
		PY_CHECK_TYPE(MInterfacePointer_Type, py_pObjectStorage, return false;);
		if (talloc_reference(r, pytalloc_get_mem_ctx(py_pObjectStorage)) == NULL) {
			PyErr_NoMemory();
			return false;
		}
		r->in.pObjectStorage = (struct MInterfacePointer *)pytalloc_get_ptr(py_pObjectStorage);
	}
	if (py_ClientImpLevel == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.ClientImpLevel");
		return false;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(r->in.ClientImpLevel));
		if (PyLong_Check(py_ClientImpLevel)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(py_ClientImpLevel);
			if (PyErr_Occurred() != NULL) {
				return false;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return false;
			}
			r->in.ClientImpLevel = test_var;
		} else if (PyInt_Check(py_ClientImpLevel)) {
			long test_var;
			test_var = PyInt_AsLong(py_ClientImpLevel);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return false;
			}
			r->in.ClientImpLevel = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return false;
		}
	}
	if (py_Mode == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.Mode");
		return false;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(r->in.Mode));
		if (PyLong_Check(py_Mode)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(py_Mode);
			if (PyErr_Occurred() != NULL) {
				return false;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return false;
			}
			r->in.Mode = test_var;
		} else if (PyInt_Check(py_Mode)) {
			long test_var;
			test_var = PyInt_AsLong(py_Mode);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return false;
			}
			r->in.Mode = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return false;
		}
	}
	PY_CHECK_TYPE(&PyList_Type, py_pIIDs, return false;);
	r->in.Interfaces = PyList_GET_SIZE(py_pIIDs);
	if (py_pIIDs == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.pIIDs");
		return false;
	}
	if (py_pIIDs == Py_None) {
		r->in.pIIDs = NULL;
	} else {
		r->in.pIIDs = NULL;
		PY_CHECK_TYPE(&PyList_Type, py_pIIDs, return false;);
		{
			int pIIDs_cntr_1;
			r->in.pIIDs = talloc_array_ptrtype(r, r->in.pIIDs, PyList_GET_SIZE(py_pIIDs));
			if (!r->in.pIIDs) { return false;; }
			talloc_set_name_const(r->in.pIIDs, "ARRAY: r->in.pIIDs");
			for (pIIDs_cntr_1 = 0; pIIDs_cntr_1 < PyList_GET_SIZE(py_pIIDs); pIIDs_cntr_1++) {
				if (PyList_GET_ITEM(py_pIIDs, pIIDs_cntr_1) == NULL) {
					PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.pIIDs[pIIDs_cntr_1]");
					return false;
				}
				PY_CHECK_TYPE(GUID_Type, PyList_GET_ITEM(py_pIIDs, pIIDs_cntr_1), return false;);
				if (talloc_reference(r->in.pIIDs, pytalloc_get_mem_ctx(PyList_GET_ITEM(py_pIIDs, pIIDs_cntr_1))) == NULL) {
					PyErr_NoMemory();
					return false;
				}
				r->in.pIIDs[pIIDs_cntr_1] = *(struct GUID *)pytalloc_get_ptr(PyList_GET_ITEM(py_pIIDs, pIIDs_cntr_1));
			}
		}
	}
	PY_CHECK_TYPE(&PyList_Type, py_protseq, return false;);
	r->in.num_protseqs = PyList_GET_SIZE(py_protseq);
	if (py_protseq == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.protseq");
		return false;
	}
	PY_CHECK_TYPE(&PyList_Type, py_protseq, return false;);
	{
		int protseq_cntr_0;
		r->in.protseq = talloc_array_ptrtype(r, r->in.protseq, PyList_GET_SIZE(py_protseq));
		if (!r->in.protseq) { return false;; }
		talloc_set_name_const(r->in.protseq, "ARRAY: r->in.protseq");
		for (protseq_cntr_0 = 0; protseq_cntr_0 < PyList_GET_SIZE(py_protseq); protseq_cntr_0++) {
			if (PyList_GET_ITEM(py_protseq, protseq_cntr_0) == NULL) {
				PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct r->in.protseq[protseq_cntr_0]");
				return false;
			}
			{
				const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(r->in.protseq[protseq_cntr_0]));
				if (PyLong_Check(PyList_GET_ITEM(py_protseq, protseq_cntr_0))) {
					unsigned long long test_var;
					test_var = PyLong_AsUnsignedLongLong(PyList_GET_ITEM(py_protseq, protseq_cntr_0));
					if (PyErr_Occurred() != NULL) {
						return false;
					}
					if (test_var > uint_max) {
						PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
						  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
						return false;
					}
					r->in.protseq[protseq_cntr_0] = test_var;
				} else if (PyInt_Check(PyList_GET_ITEM(py_protseq, protseq_cntr_0))) {
					long test_var;
					test_var = PyInt_AsLong(PyList_GET_ITEM(py_protseq, protseq_cntr_0));
					if (test_var < 0 || (unsigned long long)test_var > uint_max) {
						PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
						  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
						return false;
					}
					r->in.protseq[protseq_cntr_0] = test_var;
				} else {
					PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
					  PyInt_Type.tp_name, PyLong_Type.tp_name);
					return false;
				}
			}
		}
	}
	return true;
}

static PyObject *unpack_py_RemoteActivation_args_out(struct RemoteActivation *r)
{
	PyObject *result;
	PyObject *py_that;
	PyObject *py_pOxid;
	PyObject *py_pdsaOxidBindings;
	PyObject *py_ipidRemUnknown;
	PyObject *py_AuthnHint;
	PyObject *py_ServerVersion;
	PyObject *py_hr;
	PyObject *py_ifaces;
	PyObject *py_results;
	result = PyTuple_New(9);
	py_that = pytalloc_reference_ex(ORPCTHAT_Type, r->out.that, r->out.that);
	PyTuple_SetItem(result, 0, py_that);
	py_pOxid = ndr_PyLong_FromUnsignedLongLong(*r->out.pOxid);
	PyTuple_SetItem(result, 1, py_pOxid);
	if (*r->out.pdsaOxidBindings == NULL) {
		py_pdsaOxidBindings = Py_None;
		Py_INCREF(py_pdsaOxidBindings);
	} else {
		py_pdsaOxidBindings = pytalloc_reference_ex(DUALSTRINGARRAY_Type, *r->out.pdsaOxidBindings, *r->out.pdsaOxidBindings);
	}
	PyTuple_SetItem(result, 2, py_pdsaOxidBindings);
	py_ipidRemUnknown = pytalloc_reference_ex(GUID_Type, r->out.ipidRemUnknown, r->out.ipidRemUnknown);
	PyTuple_SetItem(result, 3, py_ipidRemUnknown);
	py_AuthnHint = ndr_PyLong_FromUnsignedLongLong((uint32_t)*r->out.AuthnHint);
	PyTuple_SetItem(result, 4, py_AuthnHint);
	py_ServerVersion = pytalloc_reference_ex(COMVERSION_Type, r->out.ServerVersion, r->out.ServerVersion);
	PyTuple_SetItem(result, 5, py_ServerVersion);
	py_hr = PyErr_FromHRESULT(*r->out.hr);
	PyTuple_SetItem(result, 6, py_hr);
	py_ifaces = PyList_New(r->in.Interfaces);
	if (py_ifaces == NULL) {
		return NULL;
	}
	{
		int ifaces_cntr_1;
		for (ifaces_cntr_1 = 0; ifaces_cntr_1 < (r->in.Interfaces); ifaces_cntr_1++) {
			PyObject *py_ifaces_1;
			if (r->out.ifaces[ifaces_cntr_1] == NULL) {
				py_ifaces_1 = Py_None;
				Py_INCREF(py_ifaces_1);
			} else {
				py_ifaces_1 = pytalloc_reference_ex(MInterfacePointer_Type, r->out.ifaces[ifaces_cntr_1], r->out.ifaces[ifaces_cntr_1]);
			}
			PyList_SetItem(py_ifaces, ifaces_cntr_1, py_ifaces_1);
		}
	}
	PyTuple_SetItem(result, 7, py_ifaces);
	py_results = PyList_New(r->in.Interfaces);
	if (py_results == NULL) {
		return NULL;
	}
	{
		int results_cntr_0;
		for (results_cntr_0 = 0; results_cntr_0 < (r->in.Interfaces); results_cntr_0++) {
			PyObject *py_results_0;
			py_results_0 = PyErr_FromHRESULT(r->out.results[results_cntr_0]);
			PyList_SetItem(py_results, results_cntr_0, py_results_0);
		}
	}
	PyTuple_SetItem(result, 8, py_results);
	if (!W_ERROR_IS_OK(r->out.result)) {
		PyErr_SetWERROR(r->out.result);
		return NULL;
	}

	return result;
}

const struct PyNdrRpcMethodDef py_ndr_IRemoteActivation_methods[] = {
	{ "RemoteActivation", "S.RemoteActivation(this_object, Clsid, pwszObjectName, pObjectStorage, ClientImpLevel, Mode, pIIDs, protseq) -> (that, pOxid, pdsaOxidBindings, ipidRemUnknown, AuthnHint, ServerVersion, hr, ifaces, results)", (py_dcerpc_call_fn)dcerpc_RemoteActivation_r, (py_data_pack_fn)pack_py_RemoteActivation_args_in, (py_data_unpack_fn)unpack_py_RemoteActivation_args_out, 0, &ndr_table_IRemoteActivation },
	{ NULL }
};

static PyObject *interface_IRemoteActivation_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return py_dcerpc_interface_init_helper(type, args, kwargs, &ndr_table_IRemoteActivation);
}

static PyTypeObject IRemoteActivation_InterfaceType = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "remact.IRemoteActivation",
	.tp_basicsize = sizeof(dcerpc_InterfaceObject),
	.tp_doc = "IRemoteActivation(binding, lp_ctx=None, credentials=None) -> connection\n"
"\n"
"binding should be a DCE/RPC binding string (for example: ncacn_ip_tcp:127.0.0.1)\n"
"lp_ctx should be a path to a smb.conf file or a param.LoadParm object\n"
"credentials should be a credentials.Credentials object.\n\n",
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = interface_IRemoteActivation_new,
};

static PyObject *syntax_IRemoteActivation_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return py_dcerpc_syntax_init_helper(type, args, kwargs, &ndr_table_IRemoteActivation.syntax_id);
}

static PyTypeObject IRemoteActivation_SyntaxType = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "remact.IRemoteActivation_abstract_syntax",
	.tp_doc = "IRemoteActivation_abstract_syntax()\n",
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = syntax_IRemoteActivation_new,
};

static PyMethodDef remact_methods[] = {
	{ NULL, NULL, 0, NULL }
};

static struct PyModuleDef moduledef = {
	PyModuleDef_HEAD_INIT,
	.m_name = "remact",
	.m_doc = "remact DCE/RPC",
	.m_size = -1,
	.m_methods = remact_methods,
};
MODULE_INIT_FUNC(remact)
{
	PyObject *m;
	PyObject *dep_samba_dcerpc_misc;
	PyObject *dep_samba_dcerpc_orpc;
	PyObject *dep_talloc;
	PyObject *dep_samba_dcerpc_base;

	dep_samba_dcerpc_misc = PyImport_ImportModule("samba.dcerpc.misc");
	if (dep_samba_dcerpc_misc == NULL)
		return NULL;

	dep_samba_dcerpc_orpc = PyImport_ImportModule("samba.dcerpc.orpc");
	if (dep_samba_dcerpc_orpc == NULL)
		return NULL;

	dep_talloc = PyImport_ImportModule("talloc");
	if (dep_talloc == NULL)
		return NULL;

	dep_samba_dcerpc_base = PyImport_ImportModule("samba.dcerpc.base");
	if (dep_samba_dcerpc_base == NULL)
		return NULL;

	ORPCTHIS_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_orpc, "ORPCTHIS");
	if (ORPCTHIS_Type == NULL)
		return NULL;

	ORPCTHAT_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_orpc, "ORPCTHAT");
	if (ORPCTHAT_Type == NULL)
		return NULL;

	GUID_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_misc, "GUID");
	if (GUID_Type == NULL)
		return NULL;

	MInterfacePointer_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_orpc, "MInterfacePointer");
	if (MInterfacePointer_Type == NULL)
		return NULL;

	DUALSTRINGARRAY_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_orpc, "DUALSTRINGARRAY");
	if (DUALSTRINGARRAY_Type == NULL)
		return NULL;

	COMVERSION_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_orpc, "COMVERSION");
	if (COMVERSION_Type == NULL)
		return NULL;

	BaseObject_Type = (PyTypeObject *)PyObject_GetAttrString(dep_talloc, "BaseObject");
	if (BaseObject_Type == NULL)
		return NULL;

	ClientConnection_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_base, "ClientConnection");
	if (ClientConnection_Type == NULL)
		return NULL;

	ndr_syntax_id_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_misc, "ndr_syntax_id");
	if (ndr_syntax_id_Type == NULL)
		return NULL;

	RemoteActivation_Type.tp_base = BaseObject_Type;
	RemoteActivation_Type.tp_basicsize = pytalloc_BaseObject_size();

	IRemoteActivation_InterfaceType.tp_base = ClientConnection_Type;

	IRemoteActivation_SyntaxType.tp_base = ndr_syntax_id_Type;
	IRemoteActivation_SyntaxType.tp_basicsize = pytalloc_BaseObject_size();

	if (PyType_Ready(&RemoteActivation_Type) < 0)
		return NULL;
	if (PyType_Ready(&IRemoteActivation_InterfaceType) < 0)
		return NULL;
	if (PyType_Ready(&IRemoteActivation_SyntaxType) < 0)
		return NULL;
	if (!PyInterface_AddNdrRpcMethods(&IRemoteActivation_InterfaceType, py_ndr_IRemoteActivation_methods))
		return NULL;

#ifdef PY_REMOTEACTIVATION_PATCH
	PY_REMOTEACTIVATION_PATCH(&RemoteActivation_Type);
#endif
#ifdef PY_IREMOTEACTIVATION_PATCH
	PY_IREMOTEACTIVATION_PATCH(&IRemoteActivation_InterfaceType);
#endif
#ifdef PY_IREMOTEACTIVATION_ABSTRACT_SYNTAX_PATCH
	PY_IREMOTEACTIVATION_ABSTRACT_SYNTAX_PATCH(&IRemoteActivation_SyntaxType);
#endif
#ifdef PY_ABSTRACT_SYNTAX_PATCH
	PY_ABSTRACT_SYNTAX_PATCH(&IRemoteActivation_SyntaxType);
#endif

	m = PyModule_Create(&moduledef);
	if (m == NULL)
		return NULL;

	PyModule_AddObject(m, "MODE_GET_CLASS_OBJECT", ndr_PyLong_FromUnsignedLongLong(0xffffffff));
	PyModule_AddObject(m, "RPC_C_IMP_LEVEL_DEFAULT", ndr_PyLong_FromUnsignedLongLong((uint32_t)RPC_C_IMP_LEVEL_DEFAULT));
	PyModule_AddObject(m, "RPC_C_IMP_LEVEL_ANONYMOUS", ndr_PyLong_FromUnsignedLongLong((uint32_t)RPC_C_IMP_LEVEL_ANONYMOUS));
	PyModule_AddObject(m, "RPC_C_IMP_LEVEL_IDENTIFY", ndr_PyLong_FromUnsignedLongLong((uint32_t)RPC_C_IMP_LEVEL_IDENTIFY));
	PyModule_AddObject(m, "RPC_C_IMP_LEVEL_IMPERSONATE", ndr_PyLong_FromUnsignedLongLong((uint32_t)RPC_C_IMP_LEVEL_IMPERSONATE));
	PyModule_AddObject(m, "RPC_C_IMP_LEVEL_DELEGATE", ndr_PyLong_FromUnsignedLongLong((uint32_t)RPC_C_IMP_LEVEL_DELEGATE));
	Py_INCREF((PyObject *)(void *)&RemoteActivation_Type);
	PyModule_AddObject(m, "RemoteActivation", (PyObject *)(void *)&RemoteActivation_Type);
	Py_INCREF((PyObject *)(void *)&IRemoteActivation_InterfaceType);
	PyModule_AddObject(m, "IRemoteActivation", (PyObject *)(void *)&IRemoteActivation_InterfaceType);
	Py_INCREF((PyObject *)(void *)&IRemoteActivation_SyntaxType);
	PyModule_AddObject(m, "IRemoteActivation_abstract_syntax", (PyObject *)(void *)&IRemoteActivation_SyntaxType);
	Py_INCREF((PyObject *)(void *)&IRemoteActivation_SyntaxType);
	PyModule_AddObject(m, "abstract_syntax", (PyObject *)(void *)&IRemoteActivation_SyntaxType);
#ifdef PY_MOD_REMACT_PATCH
	PY_MOD_REMACT_PATCH(m);
#endif
	return m;

}
